package de.accso.flexinale.security;

import de.accso.flexinale.data.model.Benutzer;
import de.accso.flexinale.data.persistence.BenutzerDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

@Service
public class BenutzerDetailsService implements UserDetailsService {

    @Autowired
    private BenutzerDao benutzerDao;

    @Override
    public UserDetails loadUserByUsername(final String login) throws UsernameNotFoundException {
        Optional<Benutzer> benutzer = benutzerDao.findByLogin(login);
        if (benutzer.isEmpty()) { // login is unique
            throw new UsernameNotFoundException("no Benutzer %s found".formatted(login));
        }
        return new UserPrincipal(benutzer.get());
    }

    public Benutzer getLoggedInBenutzer() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        String userLogin = authentication.getName();
        Optional<Benutzer> benutzer = benutzerDao.findByLogin(userLogin);

        if (benutzer.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.EXPECTATION_FAILED,
                    "None or more than one Besucher with login " + userLogin);
        }
        else {
            return benutzer.get();
        }
    }
}
